#declare ScaffoldArr_debug = 1;


#if(ScaffoldArr_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/4, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <-1000, 2000, 3000>;


#declare G_debug = 0;
#declare G_debug_L = 10;
#declare G_debug_R = 0.016;

#include "FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
#debug  "\n "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug    " ScaffoldArr is set for debug "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro ScaffoldArrMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)


//-----------------------------------------
// Var 

#local secW = 1.0295; 

#local numW = 8;
#local numH = 4*2;
#local numT = 4;

#local scaffW = secW*(numW)/(numW+.5);
#local scaffT = secW*(numT)/(numT+.68);


#local BlockW = numW*secW;
#local BlockH = numH*secW + secW;
#local BlockT = numT*secW;

//------------------------------------------------------
// Stair Section

   #include "SkyScaffoldStair_v02.Inc"

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{rgb .71} }
#local l_DoTxt = 0;

#local SkyScaffoldStairObj =
SkyScaffoldStairMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt, numH/2)

//------------------------------------------------------
// Plain Section


   #include "SkyScaffoldv01.Inc"


#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 0;

#local SkyScaffoldObj =
SkyScaffoldStairMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt, numH/2)

//-----------------------------------------
// Main 

 union{

// debug core
#local bV = <BlockW, BlockH*0+1, BlockT>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>  texture{ pigment{red 1} } }




// width
#local Count = numW-1;
#local I = 0;
#while ( I <= Count )

object{ SkyScaffoldObj  scale 1/3*scaffW translate<-scaffW/2+BlockW/2,  0,  scaffW/3+BlockT/2> + <-scaffW*I, 0, 0> } 
object{ SkyScaffoldObj  scale 1/3*scaffW translate<-scaffW/2+BlockW/2,  0,  scaffW/3+BlockT/2> + <-scaffW*I, 0, 0> rotate y*180} 


#local I = I + 1;
#end

object{ SkyScaffoldStairObj  scale 1/3*scaffW translate<-scaffW/2+BlockW/2,  0,  scaffW/3+BlockT/2> + <-scaffW*I, 0, 0> } 
object{ SkyScaffoldStairObj  scale 1/3*scaffW translate<-scaffW/2+BlockW/2,  0,  scaffW/3+BlockT/2> + <-scaffW*I, 0, 0> rotate y*180 } 


// depth

#local dh4x = -scaffT*.3; 

#local Count = numT-1;
#local I = 0;
#while ( I <= Count )

object{ SkyScaffoldObj   rotate y*90 scale 1/3*scaffT*<1, scaffW/scaffT, 1>    translate<-scaffT/3-BlockW/2,  0,  -scaffT/3+BlockT/2> + <0, 0, -scaffT*I+dh4x> } 
object{ SkyScaffoldObj rotate y*90 scale 1/3*scaffT*<1, scaffW/scaffT, 1> translate<-scaffT/3-BlockW/2,  0,  -scaffT/3+BlockT/2> + <0, 0, -scaffT*I+dh4x> rotate y*180 } 


#local I = I + 1;
#end

object{ SkyScaffoldStairObj rotate y*90 scale 1/3*scaffT*<1, scaffW/scaffT, 1> translate<scaffT/3+BlockW/2,  0,  scaffT*0.33+BlockT/2> + <0, 0, -scaffT*(I-numT)+dh4x> } 
object{ SkyScaffoldStairObj rotate y*90 scale 1/3*scaffT*<1, scaffW/scaffT, 1> translate<scaffT/3+BlockW/2,  0,  scaffT*0.33+BlockT/2> + <0, 0, -scaffT*(I-numT)+dh4x> rotate y*180 } 



      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(ScaffoldArr_debug)

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{rgb .6} }
#local l_DoTxt = 1;

#local ScaffoldArrObj =
ScaffoldArrMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ ScaffoldArrObj  rotate y*-0 } 


#local bW = 2000;
#local bH = -2;
#local bT = 2000;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>
	texture{ pigment {rgb .8 }  finish{ ambient .25 diffuse .75 }  }
    }



#end

/******************************************************/
/*
The Call


   #include "ScaffoldArr.Inc"


*/
/*******************************************************/
