#declare ScaffoldH4x_debug = 1;


#if(ScaffoldH4x_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 5;
#declare cy = 6;
#declare cz = 10;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy/4, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <-1000, 2000, 3000>;


#declare G_debug = 0;
#declare G_debug_L = 10;
#declare G_debug_R = 0.016;

#include "FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
#debug  "\n "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug    " ScaffoldH4x is set for debug "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro ScaffoldH4xMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)


//-----------------------------------------
// Var 


// - - - - - - - - - - - - - - - - - - - - - - - - - - -
// Scaffold arr

   #include "ScaffoldRW_v01p.Inc"

#local l_m = .132;


// - - - - - - - - 
// Instance01

#local l_W = 19*l_m;
#local l_H = 6*l_m;
#local l_T = 11*l_m;

#local l_Txt = texture{ pigment{rgb .6} }
#local l_DoTxt = 1;

#local l_Num = 4;

#local Scaff01Obj =
ScaffoldArrMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt, l_m, l_Num)

// - - - - - - - - 
// Instance02

#local l_W = 19*l_m;
#local l_H = 6*l_m;
#local l_T = 19*l_m;

#local l_Txt = texture{ pigment{rgb .6} }
#local l_DoTxt = 1;

#local l_Num = 6;

#local Scaff02Obj =
ScaffoldArrMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt, l_m, l_Num)

// - - - - - - - - 
// Instance03

#local l_W = 10*l_m;
#local l_H = 6*l_m;
#local l_T = 10*l_m;

#local l_Txt = texture{ pigment{rgb .6} }
#local l_DoTxt = 1;

#local l_Num = 10;

#local Scaff03Obj =
ScaffoldArrMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt, l_m, l_Num)

// - - - - - - - - 
// Instance04

#local l_W = 10*l_m;
#local l_H = 6*l_m;
#local l_T = 10*l_m;

#local l_Txt = texture{ pigment{rgb .6} }
#local l_DoTxt = 1;

#local l_Num = 14;

#local Scaff04Obj =
ScaffoldArrMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt, l_m, l_Num)

// - - - - - - - - 
// Instance05

#local l_W = 7*l_m;
#local l_H = 6*l_m;
#local l_T = 7*l_m;

#local l_Txt = texture{ pigment{rgb .6} }
#local l_DoTxt = 1;

#local l_Num = 8;

#local Scaff05Obj =
ScaffoldArrMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt, l_m, l_Num)

//-----------------------------------------
// Main 

 union{

 


#local r1 = seed(1735)

#local CountJ = 30;
#local J = -60;
#while ( J <= CountJ )

	#local CountI = 30;
	#local I = -60;
	#while ( I <= CountI )

#local cr = rand(r1)*10;

#switch (cr)


#local h3x = 20;

  #range (0, 2)

object{ Scaff01Obj translate<l_m*h3x*I,0,l_m*h3x*J> } 
    
  #break 


  #range (2, 4)
    
object{ Scaff02Obj translate<l_m*h3x*I,0,l_m*h3x*J> } 

  #break 



  #range (4, 6)

object{ Scaff03Obj translate<l_m*h3x*I,0,l_m*h3x*J> } 
    
  #break 


  #range (6, 8)

object{ Scaff04Obj translate<l_m*h3x*I,0,l_m*h3x*J> } 
    
  #break 


  #range (8, 10)

object{ Scaff05Obj translate<l_m*h3x*I,0,l_m*h3x*J> } 
    
  #break 



  #else

#end  // switch


/*
#switch (VALUE)


  #case (TEST_1)
    // This section is parsed if VALUE=TEST_1
  #break //First case ends


  #case (TEST_2)
    // This section is parsed if VALUE=TEST_2
  #break //Second case ends


  #range (LOW_1,HIGH_1)
    // This section is parsed if (VALUE>=LOW_1)&(VALUE<=HIGH_1)
  #break //Third case ends


  #range (LOW_2,HIGH_2)
    // This section is parsed if (VALUE>=LOW_2)&(VALUE<=HIGH_2)
  #break //Fourth case ends
  #else
    // This section is parsed if no other case or
    // range is true.
#end
*/



	#local I = I + 1;
	#end

#local J = J + 1;
#end




      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(ScaffoldH4x_debug)

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{red 1} }
#local l_DoTxt = 1;

#local ScaffoldH4xObj =
ScaffoldH4xMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ ScaffoldH4xObj } 


#local bW = 2000;
#local bH = -2;
#local bT = 2000;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>
	texture{ pigment {rgb .8 }  finish{ ambient .25 diffuse .75 }  }
    }


#end

/******************************************************/
/*
The Call


#ifdef(g_File_ScaffoldH4x_Used)
#else
   #declare g_File_ScaffoldH4x_Used = 1;
   #include "C:\Users\fcWork\Documents\TestFileFix\ScaffoldH4x.Inc"
   #debug "*** File ' C:\Users\fcWork\Documents\TestFileFix\ScaffoldH4x.Inc '  linked.\n"
#end


*/
/*******************************************************/
